<?php

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . 'is not allowed.');

if (!class_exists('vmPSPlugin')) {
    require JPATH_VM_PLUGINS . DS . 'vmpsplugin.php';
}

class plgVMPaymentBspb extends vmPSPlugin
{
    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $varsToPush = $this->getVarsToPush();
        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    protected function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment BSPB Table');
    }

    public function getTableSQLFields()
    {
        $SQLfields = array(
            'id' => 'int(11) unsigned NOT NULL AUTO_INCREMENT',
            'virtuemart_order_number' => 'char(32)',
            'virtuemart_order_id' => 'char(32)',
            'virtuemart_order_sum' => 'decimal(10,2)',
            'virtuemart_paymentmethod_id' => 'char(32)',
            'bank_order_id' => 'char(32)',
            'bank_session_id' => 'char(32)',
        );
        return $SQLfields;
    }

    public function plgVmConfirmedOrder($cart, $order)
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null;
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        $session = JFactory::getSession();
        $return_context = $session->getId();

        if (!class_exists('VirtueMartModelOrders')) {
            require JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php';
        }
        if (!class_exists('VirtueMartModelCurrency')) {
            require JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php';
        }

        $xml = new \SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><TKKPG></TKKPG>');
        $xmlRequest = $xml->addChild('Request');
        $xmlRequest->addChild('Operation', 'CreateOrder');
        $xmlRequest->addChild('Language', $method->language);
        $xmlOrder = $xmlRequest->addChild('Order');
        $xmlOrder->addChild('OrderType', $method->order_type);
        $xmlOrder->addChild('Merchant', $method->merchant);
        $xmlOrder->addChild('Amount', ((float)$order['details']['BT']->order_total * 100));
        $xmlOrder->addChild('Currency', $method->currency);
        $xmlOrder->addChild('Description', $method->description);

        $new_child = $xmlOrder->addChild('ApproveURL');
        if ($new_child !== NULL) {
            $node = dom_import_simplexml($new_child);
            $no   = $node->ownerDocument;
            $node->appendChild($no->createCDATASection(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&tmpl=component&type_pay=bspb'));
        }

        $new_child = $xmlOrder->addChild('CancelURL');
        if ($new_child !== NULL) {
            $node = dom_import_simplexml($new_child);
            $no   = $node->ownerDocument;
            $node->appendChild($no->createCDATASection(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&tmpl=component&type_pay=bspb'));
        }

        $new_child = $xmlOrder->addChild('DeclineURL');
        if ($new_child !== NULL) {
            $node = dom_import_simplexml($new_child);
            $no   = $node->ownerDocument;
            $node->appendChild($no->createCDATASection(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&tmpl=component&type_pay=bspb'));
        }

        
        $xmlAddParams = $xmlOrder->addChild('AddParams');
        $xmlAddParams->addChild('ShopOrderNum', $order['details']['BT']->order_number);

        $urlToBank = '';
        $err = '';
        $strResponse = $this->sendPostXml($this->getPayUrl($method), $xml->asXML(), $method->cert1, $method->cert2);
        if (is_array($strResponse) && strlen($strResponse['error']) == 0) {
            $response = $this->XmlToArray($strResponse['data']);
            if ($response['Response']['Status'] == '00') {
                $urlToBank = $response['Response']['Order']['URL'] . "?ORDERID=" . $response['Response']['Order']['OrderID'] . "&SESSIONID=" . $response['Response']['Order']['SessionID'];

                $dbValues = array();
                $dbValues['virtuemart_order_number'] = $order['details']['BT']->order_number;
                $dbValues['virtuemart_order_id'] = $order['details']['BT']->virtuemart_order_id;
                $dbValues['virtuemart_order_sum'] = $order['details']['BT']->order_total;
                $dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
                $dbValues['bank_order_id'] = $response['Response']['Order']['OrderID'];
                $dbValues['bank_session_id'] = $response['Response']['Order']['SessionID'];
                $this->storePSPluginInternalData($dbValues);
            } else {
                $err = 'Error: status ' . $response['Response']['Status'];
            }
        } else {
            $err = 'Error: ' . $strResponse['error'] .  $xml->asXML();
        }

        $html = $this->renderByLayout('form_pay', array(
            'url' => $urlToBank,
            'error' => $err,
        ));

        return $this->processConfirmedOrderPaymentResponse(true, $cart, $order, $html, $this->renderPluginName($method, $order), 'P');
    }

    function plgVmOnPaymentResponseReceived(&$html)
    {
        if (strlen($_REQUEST['xmlmsg']) > 0) {
            $data = $this->XmlToArray($_REQUEST['xmlmsg']);
            if (array_key_exists('Message', $data)) {
                $orderId = $data['Message']['OrderID'];
                $sessionId = $data['Message']['SessionID'];
            } else {
                $orderId = $data['OrderID'];
                $sessionId = $data['SessionId'];
            }

            $orderModel = VmModel::getModel('orders');
            $q = 'SELECT `virtuemart_paymentmethod_id` FROM `' . $this->_tablename . '` WHERE `bank_order_id`="' . $orderId . '" and `bank_session_id`="' . $sessionId . '"';
            $db = JFactory::getDBO();
            $db->setQuery($q);
            $virtuemart_paymentmethod_id = $db->loadResult();
            $method = $this->getVmPluginMethod($virtuemart_paymentmethod_id);

            $xml = new \SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><TKKPG></TKKPG>');
            $xmlRequest = $xml->addChild('Request');
            $xmlRequest->addChild('Operation', 'GetOrderInformation');
            $xmlRequest->addChild('Language', $method->language);
            $xmlOrder = $xmlRequest->addChild('Order');
            $xmlOrder->addChild('Merchant', $method->merchant);
            $xmlOrder->addChild('OrderID', $orderId);
            $xmlRequest->addChild('SessionID', $sessionId);
            $xmlRequest->addChild('ShowParams', 'true');
            $xmlRequest->addChild('ShowOperations', 'true');
            $xmlRequest->addChild('ClassicView', 'true');

            $strResponse = $this->sendPostXml($this->getPayUrl($method), $xml->asXML(), $method->cert1, $method->cert2);
            if (is_array($strResponse) && strlen($strResponse['error']) == 0) {
                $dataInit = $this->XmlToArray($strResponse['data']);
                if ($dataInit && $dataInit['Response']['Status'] == '00') {
                    if ($dataInit['Response']['Order']['row']['Orderstatus'] == 'APPROVED') {
                        $orderNumber = $this->findOrderId($dataInit['Response']['Order']['row']['OrderParams']['row']);
                        $virtuemartOrderId = VirtueMartModelOrders::getOrderIdByOrderNumber($orderNumber);
                        $order = $orderModel->getOrder($virtuemartOrderId);
                        if ((float)$order['details']['BT']->order_total * 100 == (float)$dataInit['Response']['Order']['row']['Amount']) {
                            $orderUpdate = array();
                            $orderUpdate['order_status'] = "C";
                            $orderUpdate['comments'] = 'BSPB';

                            if ($order['details']['BT']->order_status != "C") {
                                $orderModel->updateStatusForOneOrder($order['details']['BT']->virtuemart_order_id, $orderUpdate, true);
                                $html .= "Заказ ". $current_order['details']['BT']->order_number . " успешно оплачен.";
                                return true;
                            }
                            
                        }
                    }
                }
            }
        }

        $html .= 'Произошла ошибка. Ваш заказ не оплачен. <a href="' . JURI::root() . 'index.php?option=com_virtuemart&view=cart">Повторить оплату</a>.';
        return false;
    }

    private function getPayUrl($method)
    {
        if ($method->test) {
            return 'https://mpitest.bspb.ru:5443/Exec';
        } else {
            return 'https://mpi.bspb.ru:5443/Exec';
        }
    }

    private function sendPostXml($url, $xml, $pathCertPem, $pathCertKey)
    {
        $error = '';
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RESOLVE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSLCERT, $_SERVER['DOCUMENT_ROOT'] . "/images/virtuemart/bspb/" . $pathCertPem);
        curl_setopt($ch, CURLOPT_SSLKEY, $_SERVER['DOCUMENT_ROOT'] . "/images/virtuemart/bspb/" . $pathCertKey);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        if (!$answer = curl_exec($ch)) {
            $error = 'Error with connection: ' . curl_errno($ch);
        }
        curl_close($ch);

        return array(
            'data' => $answer,
            'error' => $error
        );
    }

    private function XmlToArray($strXml)
    {
        $strXml = str_replace("\\\"", "'", $strXml);
        $json = json_encode(simplexml_load_string($strXml));
        return json_decode($json, true);
    }

    private function findOrderId($arr)
    {
        foreach($arr as $val)
            if (is_array($val) && key_exists('PARAMNAME',$val) && key_exists('VAL',$val) && $val['PARAMNAME'] == 'ShopOrderNum')
                return $val['VAL'];
        return -1;
    }

    public function plgVmOnUserPaymentCancel()
    {
        return null;
    }

    public function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
        return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn)
    {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    public function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null;
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
        return true;
    }

    public function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    public function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    public function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    public function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        return $this->declarePluginParams('payment', $data);
    }

    protected function checkConditions($cart, $method, $cart_prices)
    {
        return true;
    }
}
